#include <avr/io.h>

#include <util/delay.h>     /* for _delay_ms() */
uint16_t read_adc(uint8_t channel)
{
    ADMUX = 0b01000000; // เลือกใช้แรงดันอ้างอิงจากขา AREF
    ADMUX |= channel;   // ตั้ง MUX ให้ชี้ไปยัง channel
    ADCSRA = 0b11000110;
   

    while ((ADCSRA & (1<<ADSC))) // รอจนบิต ADSC (บิต 6) กลายเป็น 0
        ;
    return ADCL + ADCH*256;  // ผลลัพธ์ถูกเก็บอยู่ในรีจีสเตอร์ ADCL และ ADCH
}

unsigned char d[5] = {0x00,0x00,0x00,0x00,0x00};
int dis;
int saveB;
void Time(void) {
	PORTB = 0b00111110;
	PORTC = d[dis]&0b00011111;
	PORTD = (d[dis]&0b00100000)>>5;
	PORTB = PORTB|((d[dis]&0b01000000)>>6);
	switch (dis) {
		case 0:PORTB &= 0b11111101;
			break;
		case 1:PORTB &= 0b11111011;
			break;
		case 2:PORTB &= 0b11110111;
			break;
		case 3:PORTB &= 0b11101111;
			break;
		case 4:PORTB &= 0b11011111;
			break;
	}
	dis++;
	if (dis == 5)
		dis = 0;

}
void read(void){
		uint16_t x;
	x=read_adc(5);
		if(x>600){PORTC = 0b00000000;PORTD=0;
			PORTB = 0b00111101;saveB = 5;}
		else if(x>500){PORTC = 0b00000000;PORTD=0;			
			PORTB = 0b00111011;saveB = 4;}
		else if (x>400){PORTC = 0b00000000;PORTD=0;
			PORTB = 0b00110111;saveB = 3;}
		else if (x>250){PORTC = 0b00000000;PORTD=0;
			PORTB = 0b00101111;saveB = 2;}
		else{PORTC = 0b00000000;PORTD=0;
			PORTB = 0b00011111;saveB = 1;}
}

int main(void){
	
	dis = 0;
	DDRB |= 0b00111111;
	DDRC |= 0b00011111;
	DDRD |= 0b00000001;
	int k = 0;
	int a=0;
	int i;
	for(i=0;i<1000;i++){
	d[0] = 0x01;
	d[1] = 0x00;
	d[2] = 0x00;
	d[3] = 0x01;
	d[4] = 0x01;}

	while(1){
		
		Time();
		read();
		
		if(a>2000){a=2000;}
			
		if (k == 2500){
			
		k =a;a+=5;

		
		switch(rand()%10){
			case 0:
					for (i=0;i<5;i++){read();
						d[i] *=2;}
					if(d[4]==128 && saveB ==1 || d[3]==128 && saveB == 2|| d[2]==128 && saveB == 3|| d[1]==128 && saveB == 4|| d[0]==128 && saveB ==5){
						d[0] = 0x00;
						d[1] = 0x00;
						d[2] = 0x00;
						d[3] = 0x00;
						d[4] = 0x00;
					}
				
					else if (d[0] == 128 || d[1] == 128 || d[2] == 128 || d[3] == 128 || d[4] == 128){
						d[0] = 0x00;
						d[1] = 0x00;
						d[2] = 0x01;
						d[3] = 0x01;
						d[4] = 0x01;
				
					}
					break;
			
			case 1: 
				for (i=0;i<5;i++){read();
						d[i] *=2;}
					if(d[4]==128 && saveB ==1 || d[3]==128 && saveB == 2|| d[2]==128 && saveB == 3|| d[1]==128 && saveB == 4|| d	[0]==128 && saveB ==5){
						d[0] = 0x00;
						d[1] = 0x00;
						d[2] = 0x00;
						d[3] = 0x00;
						d[4] = 0x00;
					}
					else if (d[0] == 128 || d[1] == 128 || d[2] == 128 || d[3] == 128 || d[4] == 128){
						d[0] = 0x01;
						d[1] = 0x00;
						d[2] = 0x00;
						d[3] = 0x01;
						d[4] = 0x01;

					}
					break;

			case 2:
				for (i=0;i<5;i++){read();
						d[i] *=2;}
					if(d[4]==128 && saveB ==1 || d[3]==128 && saveB == 2|| d[2]==128 && saveB == 3|| d[1]==128 && saveB == 4|| d[0]==128 && saveB ==5){
						d[0] = 0x00;
						d[1] = 0x00;
						d[2] = 0x00;
						d[3] = 0x00;
						d[4] = 0x00;
					}
					else if (d[0] == 128 || d[1] == 128 || d[2] == 128 || d[3] == 128 || d[4] == 128){
						d[0] = 0x01;
						d[1] = 0x01;
						d[2] = 0x00;
						d[3] = 0x00;
						d[4] = 0x01;

					}
					break;

			case 3:	for (i=0;i<5;i++){read();
						d[i] *=2;}
					if(d[4]==128 && saveB ==1 || d[3]==128 && saveB == 2|| d[2]==128 && saveB == 3|| d[1]==128 && saveB == 4|| d[0]==128 && saveB ==5){
						d[0] = 0x00;
						d[1] = 0x00;
						d[2] = 0x00;
						d[3] = 0x00;
						d[4] = 0x00;
					}
					else if (d[0] == 128 || d[1] == 128 || d[2] == 128 || d[3] == 128 || d[4] == 128){
						d[0] = 0x01;
						d[1] = 0x01;
						d[2] = 0x01;
						d[3] = 0x00;
						d[4] = 0x00;

					}
					break;

			case 4:	for (i=0;i<5;i++){read();
						d[i] *=2;}
					if(d[4]==128 && saveB ==1 || d[3]==128 && saveB == 2|| d[2]==128 && saveB == 3|| d[1]==128 && saveB == 4|| d[0]==128 && saveB ==5){
						d[0] = 0x00;
						d[1] = 0x00;
						d[2] = 0x00;
						d[3] = 0x00;
						d[4] = 0x00;
					}
					else if (d[0] == 128 || d[1] == 128 || d[2] == 128 || d[3] == 128 || d[4] == 128){
						d[0] = 0x00;
						d[1] = 0x01;
						d[2] = 0x00;
						d[3] = 0x01;
						d[4] = 0x01;

					}
					break;

			case 5:	for (i=0;i<5;i++){read();
						d[i] *=2;}
					if(d[4]==128 && saveB ==1 || d[3]==128 && saveB == 2|| d[2]==128 && saveB == 3|| d[1]==128 && saveB == 4|| d[0]==128 && saveB ==5){
						d[0] = 0x00;
						d[1] = 0x00;
						d[2] = 0x00;
						d[3] = 0x00;
						d[4] = 0x00;
					}
					else if (d[0] == 128 || d[1] == 128 || d[2] == 128 || d[3] == 128 || d[4] == 128){
						d[0] = 0x00;
						d[1] = 0x01;
						d[2] = 0x01;
						d[3] = 0x01;
						d[4] = 0x00;

					}
					break;

			case 6:	for (i=0;i<5;i++){read();
						d[i] *=2;}
					if(d[4]==128 && saveB ==1 || d[3]==128 && saveB == 2|| d[2]==128 && saveB == 3|| d[1]==128 && saveB == 4|| d[0]==128 && saveB ==5){
						d[0] = 0x00;
						d[1] = 0x00;
						d[2] = 0x00;
						d[3] = 0x00;
						d[4] = 0x00;
					}
					else if (d[0] == 128 || d[1] == 128 || d[2] == 128 || d[3] == 128 || d[4] == 128){
						d[0] = 0x01;
						d[1] = 0x00;
						d[2] = 0x01;
						d[3] = 0x00;
						d[4] = 0x01;

					}
					break;
			case 7:for (i=0;i<5;i++){read();
						d[i] *=2;}
					if(d[4]==128 && saveB ==1 || d[3]==128 && saveB == 2|| d[2]==128 && saveB == 3|| d[1]==128 && saveB == 4|| d[0]==128 && saveB ==5){
						d[0] = 0x00;
						d[1] = 0x00;
						d[2] = 0x00;
						d[3] = 0x00;
						d[4] = 0x00;
					}
					else if (d[0] == 128 || d[1] == 128 || d[2] == 128 || d[3] == 128 || d[4] == 128){
						d[0] = 0x01;
						d[1] = 0x01;
						d[2] = 0x00;
						d[3] = 0x01;
						d[4] = 0x00;

					}
					break;
			
			case 8:	for (i=0;i<5;i++){read();
						d[i] *=2;}
					if(d[4]==128 && saveB ==1 || d[3]==128 && saveB == 2|| d[2]==128 && saveB == 3|| d[1]==128 && saveB == 4|| d[0]==128 && saveB ==5){
						d[0] = 0x00;
						d[1] = 0x00;
						d[2] = 0x00;
						d[3] = 0x00;
						d[4] = 0x00;
					}
					else if (d[0] == 128 || d[1] == 128 || d[2] == 128 || d[3] == 128 || d[4] == 128){
						d[0] = 0x01;
						d[1] = 0x00;
						d[2] = 0x01;
						d[3] = 0x01;
						d[4] = 0x00;

					}
					break;

			case 9:	for (i=0;i<5;i++){read();
						d[i] *=2;}
				if(d[4]==128 && saveB ==1 || d[3]==128 && saveB == 2|| d[2]==128 && saveB == 3|| d[1]==128 && saveB == 4|| d[0]==128 && saveB ==5){
						d[0] = 0x00;
						d[1] = 0x00;
						d[2] = 0x00;
						d[3] = 0x00;
						d[4] = 0x00;
					}
					else if (d[0] == 128 || d[1] == 128 || d[2] == 128 || d[3] == 128 || d[4] == 128){
						d[0] = 0x00;
						d[1] = 0x01;
						d[2] = 0x01;
						d[3] = 0x00;
						d[4] = 0x01;

					}
					break;
		}
		
		}
		k++;read();
	
	}
}

